// Copyright (c) 2006, Greggman (http://games.greggman.com)
// All rights reserved.
//
// Redistribution and use in source and binary forms, with or without
// modification, are permitted provided that the following conditions are
// met:
//
// Redistributions of source code must retain the above copyright notice,this
// list of conditions and the following disclaimer.
//
// Redistributions binary form must reproduce the above copyright notice,
// this list ofconditions and the following disclaimer in the documentation
// and/or othermaterials provided with the distribution.
//
// Neither the name of Greggman nor the names of its contributors may be
// used to endorse orpromote products derived from this software without
// specific prior writtenpermission.
//
// THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND
// CONTRIBUTORS "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT
// NOT LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
// A PARTICULAR PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE COPYRIGHT
// OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
// SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED
// TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR
// PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF
// LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING
// NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS
// SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
//
// the latest version of this script can hopefully be found at
// http://games.greggman.com/pages/cutsprites/cutsprites.htm
//

// v1.4

// you would think include "cutsprites.js" would work, any reasonable programming languange
// knows that includes need to start relative to the current file.  For some reason
// adobe never got that memo so now all scripts either have to be installed inside the app folder
// or users have to learn how to set environment variables.  What were they thinking?

// notinclude "d:/work/cutsprites/cutsprites.js"

// because that is too much of a PITA I'm just duplicating the code that would have been included below


var fileRef = File.openDialog("Select a file to cut");
if (fileRef != null)
{
    open (fileRef);
    var docRef = app.activeDocument;

    var btnPnlResource =
        "dialog { panel { text: 'Build it', bounds:[15,330,365,375], " +
        "psdBtn: Button { text:'.PSD', bounds:[15,15,115,35], " +
        "properties:{name:'psd'} }, " +
        "tgaBtn: Button { text:'.TGA', bounds:[125,15,225,35], " +
        "properties:{name:'ok'} }, " +
        "cancelBtn: Button { text:'Cancel', bounds:[235,15,335,35], " +
        "properties:{name:'cancel'} }, " +
        "properties:{name:'panel' } }, " +
        "properties:{title:'Select Format to Cut too'} }";
    var dlg = new Window(btnPnlResource, 'Select Format to Cut too');
    dlg.psdBtn.onClick = function () { this.parent.close(3);};
    var result = dlg.show();

    if (result == 1 || result == 3)
    {
        var extension = ".tga";
        if (result == 3)
        {
            extension = ".psd";
        }

        CutSprites(extension);
    }

    docRef.close(SaveOptions.DONOTSAVECHANGES);
    docRef = null;
    fileRef = null;
}

function handlePsdBtn()
{
}

function createDialog()
{
    var dlg = new Window('dialog', 'Cut As');
}

function CutSprites(extension)
{
    // set units to pixels
    var strtRulerUnits = app.preferences.rulerUnits;
    if (strtRulerUnits != Units.PIXELS)
    {
        app.preferences.rulerUnits = Units.PIXELS;
    }

    var imgCount = 0;
    var docRef = app.activeDocument;
    var allPartsStr =
        "#define " + SafeName(docRef.fullName.name).toUpperCase() + "_WIDTH  " + pixelUnitsToStr(docRef.width)  + "\n" +
        "#define " + SafeName(docRef.fullName.name).toUpperCase() + "_HEIGHT " + pixelUnitsToStr(docRef.height) + "\n" +
        "#define " + SafeName(docRef.fullName.name).toUpperCase() + " \\\n";
    //alert("path=(" + docRef.fullName.path + ")\n" +
    //      "name=(" + docRef.fullName.name + ")\n");

    // for each layerset (group/folder)
    // 1) duplicate document
    // 2) find "rotpoint" layer inside set
    // 3) record rotpoint's bounds
    // 4) find "cropsize" or "kiritori" bounds
    // 5) delete other layers
    // 6) crop to size of cropsize or layer
    // 7) save as name of layerset
    {
        var layerSets = docRef.layerSets;
        var ll;
        var names = "";

        for (ll = 0; ll < layerSets.length; ll++)
        {
            var layerSet = layerSets[ll];
            var bounds   = layerSet.bounds;
            var layerName = layerSet.name.toLowerCase();

            if (layerName != "bg_color" &&
                layerName != "cropsize" &&
                layerName != "kiritori" &&
                !(layerName.length >= 3 && layerName.substring(0, 3).toLowerCase() == "ig_"))
            {
                var lname = docRef.fullName.path + "/" + StripWhiteSpace(layerSet.name) + extension;
                var bstr = CopyCropAndSave(docRef, lname, bounds, ll, -1);

                allPartsStr = allPartsStr + SpriteInfo(imgCount, lname, bstr);

                names = names + layerSet.name + "\n";
                imgCount++;
            }
        }
        //alert("layerSets:\n" + names);
    }

    // for each art layer (normal layer)
    // 1) duplicate doc
    // 2) delete other layers
    // 3) crop to size of layer
    // 4) save as name of layerset
    {
        var artLayers = docRef.artLayers;
        var ll;
        var names = "";

        for (ll = 0; ll < artLayers.length; ll++)
        {
            var artLayer = artLayers[ll];
            var bounds   = artLayer.bounds;

            var layerName = artLayer.name.toLowerCase();

            if (layerName != "bg_color" &&
                layerName != "cropsize" &&
                layerName != "kiritori" &&
                !(layerName.length >= 3 && layerName.substring(0, 3).toLowerCase() == "ig_"))
            {
                var lname = docRef.fullName.path + "/" + StripWhiteSpace(artLayer.name) + extension;
                var bstr = CopyCropAndSave(docRef, lname, bounds, -1, ll);

                allPartsStr = allPartsStr + SpriteInfo(imgCount, lname, bstr);

                names = names + artLayer.name + "\n";
                imgCount++;
            }
        }

        //alert("artLayers:\n" + names);
    }

    // save info
    {
        var infoFile = new File(docRef.fullName.absoluteURI + ".info.cpp");
        if (infoFile.exists)
        {
            infoFile.remove();
        }
        infoFile.open("w");
        infoFile.write(allPartsStr + "\n");
        infoFile.close();
        infoFile = null;
    }

    // restore units

    if (strtRulerUnits != Units.PIXELS)
    {
        app.preferences.rulerUnits = strtRulerUnits;
    }

    docRef = null;
}

//
// docRef = doc to copy
// name   = name to save as (eg, "/e/folder/myimage.psd")
// bounds = clipping bounds
// layerSetToKeep = index of layer set to keep, (-1) keep none
// artLayerToKeep   = index of art layer to leep, (-1) keep none
//
// returns info string in the following format
//  subleft,subtop,subright,subbottom,left,top,right,bottom
// where if there was a "rotpoint" those will be the bounds of the rotpoint
// otherwise they are the bounds croped to
function CopyCropAndSave(docRef, lname, bounds, layerSetToKeep, artLayerToKeep)
{
    var copyDoc = docRef.duplicate();
    var subBounds;
    var result = BoundsToString(bounds);
    var foundRot = false;
    var foundBounds = false;
    var foundBg = false;
    var isBgLayer = false;
    var orignalBounds = bounds;

    // if this is a layerSet see if there is a "rotpoint" artLayer and a "cropsize" or "kiritori"
    if (layerSetToKeep >= 0)
    {
        var layerSet = copyDoc.layerSets[layerSetToKeep];
        var ll;

        layerSet.visible = true;

        for (ll = 0; ll < layerSet.artLayers.length; ++ll)
        {
            var subArtLayer = layerSet.artLayers[ll];

            if (subArtLayer.name.toLowerCase() == "rotpoint")
            {
                subBounds = subArtLayer.bounds;
                foundRot  = true;
                subArtLayer.visible = false;
            }
            else if (subArtLayer.name.toLowerCase() == "bg_color")
            {
                subArtLayer.visible = true;
                foundBg = true;
            }
            else if (subArtLayer.name.toLowerCase() == "cropsize" ||
                     subArtLayer.name.toLowerCase() == "kiritori")
            {
                bounds = subArtLayer.bounds;
                subArtLayer.visible = false;
                subArtLayer.opacity = 0.0;
                foundBounds = true;
            }
            else if (subArtLayer.name.length >= 3 && subArtLayer.name.substring(0, 3).toLowerCase() == "ig_")
            {
                subArtLayer.visible = false;
                subArtLayer.opacity = 0.0;
            }
            else
            {
                subArtLayer.visible = true;
            }
        }
    }

    if (!foundRot)
    {
        subBounds = bounds;
    }

    // remove layerSets
    {
        var layerSets = copyDoc.layerSets;
        var ll;

        for (ll = layerSets.length - 1; ll >= 0; ll--)
        {
            if (layerSets[ll].name.toLowerCase() == "bg_color")
            {
                layerSets[ll].visible = true;
            }
            else if (ll != layerSetToKeep)
            {
                layerSets[ll].remove();
            }
        }
    }

    // turn off artSets
    {
        var artLayers = copyDoc.artLayers;
        var ll;
        var foundKeep = false;

        for (ll = artLayers.length - 1; ll >= 0; ll--)
        {
            if (artLayers[ll].name.toLowerCase() == "bg_color")
            {
                if (!foundKeep)
                {
                    artLayers[ll].visible = true;
                    foundBg = true;
                }
                else
                {
                    artLayers[ll].remove();
                }
            }
            else if (artLayers[ll].name.toLowerCase() == "cropsize" ||
                     artLayers[ll].name.toLowerCase() == "kiritori")
            {
                if (!foundBounds && !foundKeep)
                {
                    bounds = artLayers[ll].bounds;
                    foundBounds = true;
                }
                artLayers[ll].remove();
            }
            else if (ll != artLayerToKeep)
            {
                artLayers[ll].remove();
            }
            else if (ll == artLayerToKeep)
            {
                artLayers[ll].visible = true;
                foundKeep = true;;
                if (artLayers[ll].isBackgroundLayer)
                {
                    isBgLayer = true;
                }
            }
        }
    }

    // round to even numbers
    if (!foundBounds)
    {
        bounds = makeEven(bounds);
    }

    // crop
    if (!isBgLayer)
    {
        copyDoc.crop(bounds);
    }

    // check extension
    var ext = lname.substring(lname.length - 4).toLowerCase();
    if (ext == ".tga")
    {
        turnOnOff(copyDoc, "bg_color", false);

        // merge
        // first create a new blank layer so there is something to merge
        copyDoc.artLayers.add();
        copyDoc.mergeVisibleLayers();

        if (!isBgLayer)
        {
            // make transparency
            copyDoc.activeLayer = copyDoc.layers[0];

            makeAlphaFromTransparency();

            // add a black layer
            if (!foundBg)
            {
                var oldFgColor = app.foregroundColor;
                var oldBgColor = app.backgroundColor;

                var tmpColor = new SolidColor;
                tmpColor.rgb.hexValue = "000000";

                app.backgroundColor = tmpColor;
                app.foregroundColor = tmpColor;

                var blackLayer = copyDoc.artLayers.add();
                //blackLayer.kind = LayerKind.SOLIDFILL; can't do this :-( so make a normal layer and clear it
                copyDoc.selection.selectAll();
                copyDoc.selection.fill(tmpColor);
                blackLayer.move(copyDoc.layers[1], ElementPlacement.PLACEAFTER);

                app.backgroundColor = oldFgColor;
                app.foregroundColor = oldBgColor;
            }

            turnOnOff(copyDoc, "bg_color", true);
        }

        var oldDispDialogs = app.displayDialogs;
        app.displayDialogs = DialogModes.NO;

        // save as 32 bit tga
        var tgaOptions = new TargaSaveOptions;
        tgaOptions.alphaChannels = true;
        tgaOptions.resolution = TargaBitsPerPixels.THIRTYTWO;

        copyDoc.saveAs(new File(lname), tgaOptions);

        tgaOptions = null;
        app.displayDialogs = oldDispDialogs;
    }
    else
    {
        // save
        var copyFile = new File(lname);
        copyDoc.saveAs(copyFile);
        copyFile = null;
    }

    copyDoc.close(SaveOptions.DONOTSAVECHANGES);
    copyDoc = null;

    return BoundsToString(subBounds) + "," + BoundsToString(bounds);
}

function turnOnOff(doc, name, bOn)
{
    // layerSets
    {
        var layerSets = doc.layerSets;
        var ll;

        for (ll = 0; ll < layerSets.length; ++ll)
        {
            if (layerSets[ll].name.toLowerCase() == "bg_color")
            {
                layerSets[ll].visible = bOn;
            }
            else
            {
                for (sl = 0; sl < layerSets[ll].artLayers.length; ++sl)
                {
                    var subArtLayer = layerSets[ll].artLayers[sl];

                    if (subArtLayer.name.toLowerCase() == "bg_color")
                    {
                        subArtLayer.visible = bOn;
                    }
                }
            }
        }
    }

    // artSets
    {
        var artLayers = doc.artLayers;
        var ll;

        for (ll = 0; ll < artLayers.length; ++ll)
        {
            if (artLayers[ll].name.toLowerCase() == "bg_color")
            {
                artLayers[ll].visible = bOn;
            }
        }
    }
}

function makeEven(bounds)
{
    var ii;
    for (ii = 0; ii < 2; ++ii)
    {
        var dim  = parseInt(pixelUnitsToStr(bounds[ii + 2])) - parseInt(pixelUnitsToStr(bounds[ii]));

        if ((dim % 2) != 0)
        {
            bounds[ii + 2] = (parseInt(pixelUnitsToStr(bounds[ii + 2])) + 1).toString() + " px";
        }
    }
    return bounds;
}

function pixelUnitsToStr(value)
{
    var slen = value.toString().length;

    return value.toString().substring(0, slen - 3);
}

function SafeName(str)
{
    var newStr = str.replace(/^.*\//, '').replace(/\W/g, '_');
    return newStr.substring(0, newStr.length - 4);
}

function SpriteInfo(imgCount, lname, bstr)
{
    return 'SPRITEINFO(' + imgCount + ',' + SafeName(lname).toUpperCase() + ',"' + lname.replace(/^.*\//,'') + '",'
                         + bstr + ") \\\n";
}

function BoundsToString(bounds)
{
    return pixelUnitsToStr(bounds[0]) + "," +
           pixelUnitsToStr(bounds[1]) + "," +
           pixelUnitsToStr(bounds[2]) + "," +
           pixelUnitsToStr(bounds[3]) ;
}

function StripWhiteSpace(str)
{
    return str.replace(/^\b+/,'').replace(/\b+$/,'');
}

function makeAlphaFromTransparency()
{
    //  docRef.selection.load(, SelectionType.REPLACE, false)

    // =======================================================
    var id7 = charIDToTypeID( "setd" );
    var desc3 = new ActionDescriptor();
    var id8 = charIDToTypeID( "null" );
    var ref1 = new ActionReference();
    var id9 = charIDToTypeID( "Chnl" );
    var id10 = charIDToTypeID( "fsel" );
    ref1.putProperty( id9, id10 );
    desc3.putReference( id8, ref1 );
    var id11 = charIDToTypeID( "T   " );
    var ref2 = new ActionReference();
    var id12 = charIDToTypeID( "Chnl" );
    var id13 = charIDToTypeID( "Chnl" );
    var id14 = charIDToTypeID( "Trsp" );
    ref2.putEnumerated( id12, id13, id14 );
    desc3.putReference( id11, ref2 );
    executeAction( id7, desc3, DialogModes.NO );

    // =======================================================
    var id15 = charIDToTypeID( "Dplc" );
    var desc4 = new ActionDescriptor();
    var id16 = charIDToTypeID( "null" );
    var ref3 = new ActionReference();
    var id17 = charIDToTypeID( "Chnl" );
    var id18 = charIDToTypeID( "fsel" );
    ref3.putProperty( id17, id18 );
    desc4.putReference( id16, ref3 );
    var id19 = charIDToTypeID( "Nm  " );
    desc4.putString( id19, "alpha" );
    executeAction( id15, desc4, DialogModes.NO );
}




